/**
 * 
 */
package com.platomix.userprofile;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cache.annotation.EnableCaching;
import org.springframework.context.ConfigurableApplicationContext;

import com.platomix.userprofile.handler.EntrypointExecute;

/**
 * @author wookvn
 */
@EnableCaching
@SpringBootApplication
public class Application {
	
	static {
		//连接池中的1个连接最后一次使用时间后，空闲{timeBetweenEvictionRunsMillis}时间后，druid会丢弃该连接[discardConnection()],顺带打印了一个日志LOG.warn(errorMsg)
		//解决Druid报warn信息：discard long time none received connection
		//https://cloud.tencent.com/developer/article/1913502
	    System.setProperty("druid.mysql.usePingMethod", "false");
	}
	
	public static void main(String[] args) {
		ConfigurableApplicationContext applicationContext = SpringApplication.run(Application.class, args);
		applicationContext.getBean(EntrypointExecute.class).startProg();
		//测试使用
//		applicationContext.getBean(XxhAppTagHandler.class).handle("202201");
	}

}