/**
 * 
 */
package com.platomix.userprofile.config;

import java.util.Set;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Configuration;

import com.platomix.userprofile.handler.EntrypointExecute;

import lombok.Data;

/**
 * @author wookvn
 *	
 * 参数传递方式：java -jar xx.jar --profile.symbol=a --profile.month=202203 --profile.handlers=xxHandler,yyHandler 等等
 */
@Data
@Configuration
@ConfigurationProperties(prefix = "profile")
public class ConfigProperties {

	/**
	 * 执行标记[参考 {@link EntrypointExecute#startProg()}]
	 */
	private String symbol;
	
	/**
	 * 执行月份[默认：上个月，格式：yyyyMM]
	 */
	private String month;
	
	/**
	 * 结束月份[默认与{@link #month}相同，格式：yyyyMM]
	 */
	private String endMonth;
	
	/**
	 * 执行的handler名称，多个逗号隔开
	 */
	private Set<String> handlers;
	
	/**
	 * 信息化大网最新月份数据(不需要传递，系统启动时自动计算)
	 */
	private String xxhLatestMonth;
	
	/**
	 * 其他数据[比如：<从135向新的库拷贝>的SQL字符串]
	 */
	private String ext;
}
