/**
 * 
 */
package com.platomix.userprofile.handler.core;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.platomix.userprofile.enums.DsEnum;
import com.platomix.userprofile.handler.AbstractTagHandler;
import com.platomix.userprofile.model.UserprofileTag;
import com.platomix.userprofile.service.UserprofileTagService;
import com.platomix.userprofile.utils.StrBuilder;

/**
 * @author wookvn
 * 	
 * RMF标签
 *
 */
//@Slf4j
@Service
public class RmfTagHandler extends AbstractTagHandler {

	final static String ZT_TABLE_NAME = "ads.ZT_USER_RFM";
	
	@Autowired
	private UserprofileTagService userprofileTagService;
	
	@Override
	public void invoke(String month, String mobileLeft, String mobileRight) {
		// 查询所有标签
		List<UserprofileTag> tagList = userprofileTagService.list();
		Map<String, List<UserprofileTag>> tagListMap = tagList.stream().collect(Collectors.groupingBy(t -> t.getEnglishName().toLowerCase()));

//		String lrMobileSql = mobileLeft == null || mobileRight == null ? "" : String.format(" and USERID>='%s' and USERID<'%s'", mobileLeft, mobileRight);
		
		StrBuilder sqlBuilder = new StrBuilder();
		sqlBuilder.appendLn(super.buildTableSql(ZT_TABLE_NAME, "THEMONTH_RFM", "USERID_RFM"));
		sqlBuilder.append("select").append("'"+month+"'").appendLn(" as THEMONTH_RFM,").append("DEVICE_NUMBER as USERID_RFM,");
		//标签范围值
		String sql = genBucketSql("tag_rfm", "USER_LABEL", "USER_LABEL", tagListMap.get("tag_rfm"));
		sqlBuilder.appendLn(sql);
		sqlBuilder.appendLn(String.format("from ads.ADS_RFLV_LABEL where MONTH_ID='%s'",month));
//		log.info("\n" + sqlBuilder.toString());
		dynamicExecuteService.execute(DsEnum.clickhouse, sqlBuilder.toString(), "["+ZT_TABLE_NAME+"]RMF标签生成");
	}

	@Override
	public String tableName(String month) {
		return ZT_TABLE_NAME;
	}
}
