/**
 * 
 */
package com.platomix.userprofile.handler.support;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.platomix.userprofile.model.UserprofileTag;
import com.platomix.userprofile.service.UserprofileTagService;

/**
 * @author wookvn
 *	静态标签值生成
 */
@Component
public class UserTagStaticManager {

	@Autowired
	private UserprofileTagService tagService;
	
	/**
	 * 生成微信公众号和小程序标签[产品标签]
	 * 关注公众号的标签值：1、已关注  2、已取关  3、未关注
	 * 针对小程序的标签值：1、未绑定  2、已绑定
	 */
	public void genWeixinBind() {
		List<UserprofileTag> tagList = new ArrayList<>();
		String level1id = "B"; int level2index = 33;
		//是否关注公众号
		tagList.add(new UserprofileTag(String.format("%s112_%02d_%03d", level1id, level2index, 1), 
				"已取关", null, level1id, "产品标签", level1id + level2index, "是否关注公众号", "tag_wxpublic_bind", "0", 0,
				"String", "String", "是否关注公众号", 1));
		tagList.add(new UserprofileTag(String.format("%s112_%02d_%03d", level1id, level2index, 2), 
				"已关注", null, level1id, "产品标签", level1id + level2index, "是否关注公众号", "tag_wxpublic_bind", "0", 0,
				"String", "String", "是否关注公众号", 2));
		tagList.add(new UserprofileTag(String.format("%s112_%02d_%03d", level1id, level2index, 3), 
				"未关注", null, level1id, "产品标签", level1id + level2index, "是否关注公众号", "tag_wxpublic_bind", "0", 0,
				"String", "String", "是否关注公众号", 3));
		//是否绑定小程序
		int wxappLevel2index = 34;
		tagList.add(new UserprofileTag(String.format("%s112_%02d_%03d", level1id, wxappLevel2index, 1), 
				"已绑定", null, level1id, "产品标签", level1id + wxappLevel2index, "是否绑定小程序", "tag_wxapp_bind", "0", 0,
				"String", "String", "是否绑定小程序", 1));
		tagList.add(new UserprofileTag(String.format("%s112_%02d_%03d", level1id, wxappLevel2index, 2), 
				"未绑定", null, level1id, "产品标签", level1id + wxappLevel2index, "是否绑定小程序", "tag_wxapp_bind", "0", 0,
				"String", "String", "是否绑定小程序", 2));
		tagService.saveBatch(tagList);
	}
}
