/**
 * 
 */
package com.platomix.userprofile.utils;

import java.io.File;
import java.io.IOException;

import org.apache.commons.io.FileUtils;

import com.platomix.userprofile.model.ShellCommond;

import cn.hutool.core.io.IoUtil;
import cn.hutool.core.io.LineHandler;
import cn.hutool.core.util.RuntimeUtil;
import lombok.extern.slf4j.Slf4j;

/**
 * @author wookvn
 *
 *	辅助工具类
 */
@Slf4j
public class ShellUtils {

	final public static String SHELL_DIC = "shell/";

	/**
	 * 生成shell并执行
	 * @param shellData
	 * @throws IOException
	 */
	public static void shellToCluster(ShellCommond shellData) throws IOException, InterruptedException {
		String filePath = getShellFilePath(shellData);
		File shellFile = new File(filePath);
		FileUtils.writeStringToFile(shellFile, shellData.getShellCmd(), "UTF-8");
		//权限设置
		Runtime.getRuntime().exec("chmod 777 " + filePath);
		//执行脚本命令
		String command = "sh " + shellFile.getAbsolutePath();
		Process process = RuntimeUtil.exec(command);
		try {
			//防止缓存区堆满，开启2个线程，打印执行任务子进程的信息
			new Thread(() -> {
				try {
					int[] index = new int[1];
					IoUtil.readUtf8Lines(process.getInputStream(), (LineHandler) msg -> {
						int i = index[0]++;
						if(i % 10 == 0 || i < 2) { // 超过10次打印一下[前2下都打印，可能有一些关键信息]
							log.info("ip:{}|{}", shellData.getIp(), msg);
						}
					});
				} catch (Exception e) {
//					log.error(e.getMessage());
				}
			}).start();
			new Thread(() -> {
				try {
					int[] index = new int[1];
					IoUtil.readUtf8Lines(process.getErrorStream(), (LineHandler) msg -> {
						int i = index[0]++;
						if(i % 10 == 0 || i < 2) { // 超过10次打印一下
							log.error("ip:{}|{}", shellData.getIp(), msg);
						}
					});
				} catch (Exception e) {
//					log.error(e.getMessage());
				}
			}).start();
			log.info("======任务执行完成之前,阻塞[{}]主线程====", shellData.getIp());
			//阻塞，等待命令结束
			int exit = process.waitFor();
			if(exit == 0) {
				log.info("[{}]子进程正常完成", shellData.getIp());
			}else {
				log.info("[{}]子进程正常完成", shellData.getIp());
			}
		} catch (Exception e) {
			log.error(e.getMessage());
		} finally {
			//执行完成，destory
			if(process != null) process.destroy();
		}
	}

	/**
	 * 获取shell文件路径
	 * @param shellData
	 * @return
	 */
	private static String getShellFilePath(ShellCommond shellData){
		return 	SHELL_DIC + "to"+shellData.getIp().replace('.','_')+".sh";
	}
}
